         section  text
         xdef     do_vect
         xdef     use_thg
         xdef     free_thg
;         xdef     h_stuff          ENDed out
         xdef     get_thvect

; use thing: uses thing to which A0 points on entry
; on exit:
; D1 - D3 , A1-A2: result returned from use code
; all other regs preserved, D0 and condition codes set on exit

use_thg  MOVEQ    #-1,D1
         MOVEQ    #-1,D3
         MOVEQ    #$28,D0
         BRA.S    do_vect

; free thing: frees thing to which A0 points on entry
; on exit: D1, D3 smashed, A2 returned result
; all other regs preserved, D0 and condition codes set on exit

free_thg MOVEQ    #-1,D1
         MOVEQ    #-1,D3
         MOVEQ    #$29,D0

do_vect  MOVE.L   A4,-(A7)
         MOVE.L   D0,-(A7)          ; stock D0 for call to function
         BSR.S    get_thvect
         BNE.S    thvecerr
         MOVE.L   (A7)+,D0
         JSR      (A4)
         BRA.S    thvecok
thvecerr ADDQ.L   #$04,A7
thvecok  MOVE.L   (A7)+,A4
         TST.L    D0
         RTS


; GET_THVECT   : get thing vector into A4
; all regs preserved, except A4 and D0.
; condition codes set on exit

get_thvect MOVEM.L          D1-D2/A0/A1,-(A7)
         MOVEQ    #0,D0             ; SMS_INFO
         TRAP     #$01
         MOVE.L   $B8(A0),D1        ; SYS_THGL
         BEQ.S    no_thing
         MOVEA.L  D1,A0
get_loop MOVE.L   (A0),D1
         BEQ.S    found_th
         MOVEA.L  D1,A0
         BRA.S    get_loop
found_th MOVE.L   $10(A0),A0
         CMP.L    #-1,4(A0)
         BNE.S    no_thing
         MOVE.L   8(A0),A4
get_out  MOVEM.L  (A7)+,D1-D2/A0/A1
         TST.L    D0
         RTS
no_thing MOVEQ    #-$13,D0          ; ERR_NIMP
         BRA.S    get_out

         end


h_stuff  TRAP     #0                         ; SMS_SUPERV
         MOVEM.L  D2-D3/A0-A3,-(A7)
         MOVEQ    #0,D0                      ; SMS_INFO
         TRAP     #1
         MOVEQ    #0,D1
         LEA      $3C(A0),A0                 ; SYS_POLL
hs_loop  MOVE.L   (A0),D0
         BEQ.S    hs_out
         MOVEA.L  D0,A0
         CMPI.L   #'Hot%',8(A0)
         BNE.S    hs_loop
         CLR.W    $36(A0)
         MOVE.W   #1,$32(A0)
         LEA      $38(A0),A1
         MOVEM.L  (A7),D2-D3
         BSR.S    do_it
         MOVE.W   D3,D2
         MOVEA.L  A3,A2
         BSR.S    do_it
         MOVE.W   D1,$36(A0)
hs_out   MOVEM.L  (A7)+,D2-D3/A0-A3
         ANDI.W   #$DFFF,SR                  ; USER mode again
         MOVEQ    #$0,D0
         RTS

do_it    ADD.W    D2,D1
         MOVE.W   $34(A0),D0
         SUB.W    D1,D0
         BGE.S    do1
         ADD.W    D0,D1
         ADD.W    D0,D2
do1      MOVE.W   D2,D0
         BRA.S    do2
do_loop  MOVE.B   (A2)+,(A1)+
do2      DBF      D0,do_loop

         RTS

         end
