******************************************************************************
; gu_achp0; Allocates Common Heap for job 0
; gu_achp: Allocates comme heap for myself
; entry				exit

; D0 number of bytes to get		error or 0
; A0.L				base of area allocated

; all other my_reg kept
; condition codes set according to old D0
	section	gu_achp
	xdef	gu_achp
	xdef	gu_achp0
my_reg	REG	D1-D3/A1-A3

gu_achp0	MOVEM.L	my_reg,-(A7)   ; this gets mem for BASIC
	MOVEQ	#0,D2
	BRA.S	get_mem
gu_achp	MOVEM.L	my_reg,-(A7)   ; this gets mem for current job
	MOVEQ	#-1,D2
get_mem	MOVE.L	D0,D1		; this does get mem ops
	MOVEQ	#$18,D0		; MT_ALCHP
	TRAP	#$1
	TST.L	D0
	MOVEM.L	(A7)+,my_reg
	RTS
	end
