#       Makefile for ProWesS
#
# possible flags
# none define just yet
DEFINES =
# specify compiler etc
CC =    cc
CFLAGS = -c -O
LD =    ld
MAC = qmac

test_wolf : test_wolf_o
        ${LD} -ms -otest_wolf test_wolf_o \
        -lpw -lsms -lpf -sexec
        mkexec test_wolf \"ProWesS speed test\"

_c_o : ; ${CC} ${CFLAGS} ${DEFINES} $<

_s_o : ; ${CC} -c $<

_asm_rel : ; ${MAC} $<


# rules to build some special files

core-lib_o core-dll_o : core_dll
    conv core
    cc -c core-lib_s
    cc -c core-dll_s
    rm core-dll_s core-lib_s

pws-lib_o pws-dll_o : pws_dll
    conv pws
    cc -c pws-lib_s
    cc -c pws-dll_s
    rm pws-dll_s pws-lib_s
     
